import struct

try:
    from Crypto import Util
except ImportError:
    warnings.warn("PyCrypto not installed, but continuing anyways!",
     RuntimeWarning)
            
class SSHUtil:
    @staticmethod
    def Int2SSHNum(number):
        if number==0: return '\000'*4
        assert number>0
        bn = Util.number.long_to_bytes(number)
        if ord(bn[0])&128:
            bn = '\000' + bn
        return struct.pack('>L',len(bn)) + bn

    @staticmethod
    def Str2SSHStr(t):
        return struct.pack('!L',len(t)) + t

