

from PythonSSH.Server.SSHShell import SSHShell


class MySSHShell(SSHShell):

    def __init__(self, *args):
        SSHShell.__init__(self, *args);
        self.mydict = {}

    def connectionMade(self): 
        SSHShell.connectionMade(self)
        self.write("Welcome to my test SSH server.")
        self.nextLine()
        self.do_help()
        self.showPrompt()

    def do_echo(self, *args):
        "Echo a string. Usage: echo my line of text"
        self.write(" ".join(args))
        self.nextLine()

    def do_quit(self):
        "Ends your session. Usage: quit"
        self.write("Thanks for playing!")
        self.nextLine()
        self.terminal.loseConnection()

    def do_clear(self):
        "Clears the screen. Usage: clear"
        self.reset()

    def do_mult(self, x, y):
        """
        Multiple two numbers together. Usage: mult x y
        ...try large numbers
        """
        pass #STUDENT WORK GOES HERE
        
    
    
    def do_fact(self, n):
        "Computes the factorial of a number. Usage: fact n"
        pass #STUDENT WORK GOES HERE

    def do_loop(self, n):
        "Loops from 1 to n (n is positive). Usage: loop n"
        pass #STUDENT WORK GOES HERE
            
    def do_max(self, *args):
        "Find the max of a list of integers. Usage: max n1 n2 n3 n4 ..."
        pass #STUDENT WORK GOES HERE
        
    def do_max_lambda(self, *args):
        "The same as max, but uses python's map() and reduce() and lambda functions. Usage: max_reduce n1 n2 n3 n4 ..."
        pass #STUDENT WORK GOES HERE

        
    def do_sum(self, *args):
        "Find the sum of a list of integers. Usage sum n1 n2 n3 n4 ..."
        pass #STUDENT WORK GOES HERE
 
        
    def do_sum_lambda(self, *args):
        "Find the sum of a list of integers using Python's lambda functions. Usage sum n1 n2 n3 n4 ..."
        pass #STUDENT WORK GOES HERE
        
    def do_sort(self, *args):
        "Sort a list of integers. Usage sort n1 n2 n3 n4 ..."
        pass #STUDENT WORK GOES HERE
        
        
    def do_dict_put(self, key, value):
        "Add an item to a dictionary. Usage: dict_put key value (store a value in the dict)"
        pass #STUDENT WORK GOES HERE

    def do_dict_get(self, key):
        "Print out key's value. Usage: dict_get key"
        pass #STUDENT WORK GOES HERE

    def do_dict_test(self, key):
        "Test an item's existence in a dictionary. Usage: dict_test key (print out True/False == if a key exists)"
        pass #STUDENT WORK GOES HERE

    def do_dict_list(self):
        "Print out all key/value pairs in dict. Usage: dict_list"
        pass #STUDENT WORK GOES HERE

    def do_myhelp(self):
        "Simply call the superclass's help function"
        pass #STUDENT WORK GOES HERE


    def do_rss(self):
        "Retreives an RSS feed and print out the titles. Usage: rss"
        pass #STUDENT WORK GOES HERE
